package com.qgs.dc.mq.configuration;


import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Desc: "设备：PID10 相关信息定义"
 * @Author: caixiang
 * @DATE: 2021/6/7 9:11
 */
@Configuration
public class ConfigOfPID10 {

    //水平扩展其他设备的时候 只要：control+R 然后 PID10=>00C  然后replace all
    public static final String EQUIPMENT_NAME_PID10 = "PID10";

    public static final String EXCHANGE_NAME_PID10 = EQUIPMENT_NAME_PID10 +"_Exchange";
    public static final String EAP_REQUEST_QUEUE_PID10 = EQUIPMENT_NAME_PID10 +"_EAP_Request_Queue";
    public static final String EAP_RESPONSE_QUEUE_PID10 = EQUIPMENT_NAME_PID10 +"_EAP_Response_Queue";
    public static final String MES_REQUEST_QUEUE_PID10 = EQUIPMENT_NAME_PID10 +"_MES_Request_Queue";
    public static final String MES_RESPONSE_QUEUE_PID10 = EQUIPMENT_NAME_PID10 +"_MES_Response_Queue";
    public static final String EAP_REQUEST_QUEUE_ROUTINGKEY_PID10 = EQUIPMENT_NAME_PID10 +"_EAP_Request_Queue_RoutingKey";
    public static final String EAP_RESPONSE_QUEUE_ROUTINGKEY_PID10 = EQUIPMENT_NAME_PID10 +"_EAP_Response_Queue_RoutingKey";
    public static final String MES_REQUEST_QUEUE_ROUTINGKEY_PID10 = EQUIPMENT_NAME_PID10 +"_MES_Request_Queue_RoutingKey";
    public static final String MES_RESPONSE_QUEUE_ROUTINGKEY_PID10 = EQUIPMENT_NAME_PID10 +"_MES_Response_Queue_RoutingKey";


    @Bean
    public DirectExchange EXCHANGE_NAME_PID10(){
        return new DirectExchange(EXCHANGE_NAME_PID10);
    }

    //todo
    @Bean
    public Queue MES_REQUEST_QUEUE_PID10(){
        Queue queue = new Queue(MES_REQUEST_QUEUE_PID10);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }
    @Bean
    public Queue MES_RESPONSE_QUEUE_PID10(){
        Queue queue = new Queue(MES_RESPONSE_QUEUE_PID10);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }


    @Bean
    public Queue EAP_REQUEST_QUEUE_PID10(){
        Queue queue = new Queue(EAP_REQUEST_QUEUE_PID10);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;

    }
    @Bean
    public Queue EAP_RESPONSE_QUEUE_PID10(){
        Queue queue = new Queue(EAP_RESPONSE_QUEUE_PID10);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }


    @Bean
    public Binding bindExchangeAndQueueA_PID10(){
        return BindingBuilder.bind(EAP_REQUEST_QUEUE_PID10()).to(EXCHANGE_NAME_PID10())
                .with(EAP_REQUEST_QUEUE_ROUTINGKEY_PID10);
    }
    @Bean
    public Binding bindExchangeAndQueueB_PID10(){
        return BindingBuilder.bind(EAP_RESPONSE_QUEUE_PID10()).to(EXCHANGE_NAME_PID10())
                .with(EAP_RESPONSE_QUEUE_ROUTINGKEY_PID10);
    }

    @Bean
    public Binding bindExchangeAndQueueC_PID10(){
        return BindingBuilder.bind(MES_REQUEST_QUEUE_PID10()).to(EXCHANGE_NAME_PID10())
                .with(MES_REQUEST_QUEUE_ROUTINGKEY_PID10);
    }

    @Bean
    public Binding bindExchangeAndQueueD_PID10(){
        return BindingBuilder.bind(MES_RESPONSE_QUEUE_PID10()).to(EXCHANGE_NAME_PID10())
                .with(MES_RESPONSE_QUEUE_ROUTINGKEY_PID10);
    }
}